class ConnectionProvider:
    """데이터베이스 연결을 제공하기 위한 추상 인터페이스."""
    
    def get_connection(self):
        """DB 연결 객체를 반환합니다."""
        raise NotImplementedError

    def release_connection(self, conn):
        """사용한 DB 연결을 반환합니다."""
        raise NotImplementedError